#ifndef NET_H
#define NET_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "netproto.h"

NET *net_new(void)
{

  strcpy(net.ip, "0.0.0.0");
  strcpy(net.interf, "wlan0");
  strcpy(net.mac, "54:04:a6:45:d5:50");
  strcpy(net.mtu, "1500");
  strcpy(net.w.rate, "1M");
  strcpy(net.w.rts, "off");
  strcpy(net.w.frag, "off");
  strcpy(net.w.txpower, "auto");
  strcpy(net.w.essid, "WIFI_ETECSA");

  return &net;
}

void net_set_interf(NET *n, const char *interf)
{
 strcpy(n->interf, interf);
}


void net_wifi_dump(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  strcpy(cmd, "iw dev ");
  strcat(cmd, n->interf);
  strcat(cmd, " link");

  f = popen(cmd, "r");

  if(f == NULL)
   ;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);

 f = fopen("/tmp/datoswifi", "w");

 if(f == NULL)
  ;
 else
 {
  fputs(buf, f);
  fclose(f);
 }
}

void net_dump(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  strcpy(cmd, "ip addr show dev ");
  strcat(cmd, n->interf);

  f = popen(cmd, "r");

  if(f == NULL)
   ;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);

 f = fopen("/tmp/datosnet", "w");

 if(f == NULL)
  ;
 else
 {
  fputs(buf, f);
  fclose(f);
 }
}

char * net_wifi_get_ssid(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  net_wifi_dump(n);

  strcpy(cmd, "cat /tmp/datoswifi|grep \"SSID\"|cut -f2 -d\":\"");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      if(buf[i] == ' ') buf[i] = '\r';
      if(buf[i] == '\n') buf[i] = '\r';

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);

  if(strcmp(buf, "") == 0) return "Desconectado";

  return strdup(buf);
}


char * net_wifi_get_signal(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  net_wifi_dump(n);

  strcpy(cmd, "cat /tmp/datoswifi|grep \"sign\"|cut -f2 -d\":\"");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      if(buf[0] == ' ') buf[i] = '\r';
      if(buf[i] == '\n') buf[i] = '\r';

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);


  if(strcmp(buf, "") == 0) return "Desconectado";

  return strdup(buf);
}

char * net_get_ip(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  net_dump(n);

  strcpy(cmd, "cat /tmp/datosnet|grep inet|grep global|cut -d\"/\" -f1|cut -d\"t\" -f2");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      if(buf[0] == ' ') buf[i] = '\r';
      if(buf[i] == '\n') buf[i] = '\r';

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);

  if(strcmp(buf, "") == 0) return "Desconectado";

  return strdup(buf);
}

char * net_get_mac(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  net_dump(n);

  strcpy(cmd, "cat /tmp/datosnet|grep \"link/\"|cut -d\"r\" -f2|cut -d\" \" -f2");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      if(buf[i] == ' ') buf[i] = '\r';
      if(buf[i] == '\n') buf[i] = '\r';

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);

  if(strcmp(buf, "") == 0) return "no mac";
  return strdup(buf);
}

char * net_get_gateway(NET *n)
{
  char cmd[80] = {'\0'};
  char buf[1024] = {'\0'};
  int i = 0;
  FILE *f = NULL;

  net_dump(n);
  strcpy(cmd, "ip route show dev ");
  strcat(cmd, n->interf);
  strcat(cmd, "|grep default|cut -d\" \" -f3");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;
  else
  {
    while(!feof(f))
    {
      buf[i] = fgetc(f);
      if(buf[i] == EOF)
       break;

      if(buf[i] == ' ') buf[i] = '\r';
      if(buf[i] == '\n') buf[i] = '\r';

      ++i;
    }
    buf[i] = '\0';
  }
  pclose(f);


  if(strcmp(buf, "") == 0) return "no pasarela";

  return strdup(buf);
}

void net_activate_interf(NET *n)
{
 char cmd[80] = {'\0'};
 FILE *f = NULL;

 strcpy(cmd, "ip link set ");
 strcat(cmd, n->interf);
 strcat(cmd, " up");

 f = popen(cmd, "r");
 if(f == NULL) ; else
 {
  printf("Activando tarjeta de red %s\n", n->interf); 
  sleep(1);
 }
 pclose(f);

}


void net_deactivate_interf(NET *n)
{
 char cmd[80] = {'\0'};
 FILE *f = NULL;

 strcpy(cmd, "ip link set ");
 strcat(cmd, n->interf);
 strcat(cmd, " down");

 f = popen(cmd, "r");
 if(f == NULL) ; else
 {
  printf("Desactivando tarjeta de red %s\n", n->interf); 
  sleep(2);
 }
 pclose(f);

 net_flush_ip(n); /* Liberar la ips de la tarjeta evita problemas de parseo */

}

void net_flush_ip(NET *n)
{
    char cmd[80] = {'\0'};
    FILE *f = NULL;

    strcpy(cmd, "ip address flush dev ");
    strcat(cmd, n->interf);
    strcat(cmd, " scope global");

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Liberando IP en %s\n", n->interf, n->ip); 
    }

   pclose(f);


}

void net_set_ip(NET *n, const char *ip)
{
   strcpy(n->ip, ip);
}

void net_set_mac(NET *n, const char *mac)
{
   strcpy(n->mac, mac);
}

void net_apply_config(NET *n)
{
    char cmd[80] = {'\0'};
    FILE *f = NULL;

    net_deactivate_interf(n);

    /* Poner MAC */
    strcpy(cmd, "ip link set dev ");
    strcat(cmd, n->interf);
    strcat(cmd, " address ");
    strcat(cmd, n->mac);

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Definiendo MAC via ip en %s = %s\n", n->interf, n->mac); 
    }

   pclose(f);

   strcpy(cmd, "ifconfig  ");
   strcat(cmd, n->interf);
   strcat(cmd, " hw ether ");
   strcat(cmd, n->mac);

   f = popen(cmd, "r");
   if(f == NULL) ; else
   {
    printf("Definiendo MAC via ifconfig en %s = %s\n", n->interf, n->mac); 
   }

   pclose(f);

 
  /*--------------------------------------------------------------------*/

    /* Poner IP */
    net_flush_ip(n);
    strcpy(cmd, "ip address add ");
    strcat(cmd, n->ip);
    strcat(cmd, "/24 dev ");
    strcat(cmd, n->interf);

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Definiendo IP via ip en %s = %s\n", n->interf, n->ip); 
    }

   pclose(f);

    strcpy(cmd, "ifconfig ");
    strcat(cmd, n->interf);
    strcat(cmd, " ");
    strcat(cmd, n->ip);

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Definiendo IP via ifconfig en %s = %s\n", n->interf, n->ip); 
    }

   pclose(f);

  /*------------------------------------------------------------------------*/
  /* Poner rutas */

    strcpy(cmd, "route add default gw ");
    strcat(cmd, n->gateway);
    strcat(cmd, " dev ");
    strcat(cmd, n->interf);

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Definiendo pasarela via route en %s = %s\n", n->interf, n->gateway); 
    }
    pclose(f);

    strcpy(cmd, "ip route add default via ");
    strcat(cmd, n->gateway);
    strcat(cmd, " dev ");
    strcat(cmd, n->interf);

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Definiendo pasarela via ip en %s = %s\n", n->interf, n->gateway); 
    }
    pclose(f);

   net_activate_interf(n);

}

void net_stop_nmanager(void)
{
    char cmd[80] = {'\0'};
    FILE *f = NULL;

    strcpy(cmd, "systemctl stop network-manager");

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Cerrando administrador de red NetworkManager\n"); 
    }

   pclose(f);
}

void net_start_nmanager(void)
{
    char cmd[80] = {'\0'};
    FILE *f = NULL;

    strcpy(cmd, "systemctl start network-manager");

    f = popen(cmd, "r");
    if(f == NULL) ; else
    {
     printf("Corriendo administrador de red NetworkManager\n\n"); 
    }

   pclose(f);
}

void net_set_gateway(NET *n, const char *gateway)
{
  strcpy(n->gateway, gateway);
}


const char **net_get_dns_list()
{
  char cmd[80] = {'\0'};
  FILE *f = NULL;
  static const char *lst[100];
  int k = 0, i = 0;
  char buf[2000] = {'\0'};

  strcpy(cmd, "cat /etc/resolv.conf |grep -v search|grep -v \"#\"|cut -d\" \" -f2");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;

  while(!feof(f))
  {
    buf[k] = fgetc(f);
    if(buf[k] == EOF) { buf[k] = '\0'; buf[k - 1] = '\0' /* Quia linea blanco */; break; }

   ++k;
  }

  pclose(f);

  puts("=== DNS archivo local ===");
  puts(buf);
  puts("===== DNS a bufer= ======");

  lst[i] = strtok(buf, "\n");  
  while(lst[i] != NULL)
  {
    lst[++i] = strtok(NULL, "\n");
  }

 return lst;

}

#endif
