#ifndef NETPROTO_H
#define NETPROTO_H

struct WIRELESS
{
  char rate[20];
  char rts[20];
  char frag[20];
  char txpower[20];
  char essid[20];
  char signal[20];
};



struct SNET
{
  char ip[20];
  char interf[20];
  char mac[20];
  char mtu[20];
  char gateway[20];
  struct WIRELESS w;

};

typedef struct SNET NET;
NET net;


NET *net_new(void);
void net_set_interf(NET *n, const char *interf);
void net_wifi_dump(NET *n);
void net_dump(NET *n);
char * net_wifi_get_ssid(NET *n);
char * net_wifi_get_signal(NET *n);
char * net_get_ip(NET *n);
char * net_get_mac(NET *n);
char * net_get_gateway(NET *n);
void net_activate_interf(NET *n);
void net_deactivate_interf(NET *n);
void net_set_ip(NET *n, const char *ip);
void net_set_mac(NET *n, const char *mac);
void net_set_gateway(NET *, const char *gateway);
void net_flush_ip(NET *n);
void net_apply_config(NET *n);
void net_stop_nmanager(void);
void net_start_nmanager(void);
const char **net_get_dns_list();
#endif
